# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from openapi_server.models.base_model_ import Model
from openapi_server import util


class QuoteItem(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id=None, quote_text=None, quote_author=None, quote_likes=None, quote_tags=None):  # noqa: E501
        """QuoteItem - a model defined in OpenAPI

        :param id: The id of this QuoteItem.  # noqa: E501
        :type id: int
        :param quote_text: The quote_text of this QuoteItem.  # noqa: E501
        :type quote_text: str
        :param quote_author: The quote_author of this QuoteItem.  # noqa: E501
        :type quote_author: str
        :param quote_likes: The quote_likes of this QuoteItem.  # noqa: E501
        :type quote_likes: int
        :param quote_tags: The quote_tags of this QuoteItem.  # noqa: E501
        :type quote_tags: str
        """
        self.openapi_types = {
            'id': int,
            'quote_text': str,
            'quote_author': str,
            'quote_likes': int,
            'quote_tags': str
        }

        self.attribute_map = {
            'id': 'id',
            'quote_text': 'quote_text',
            'quote_author': 'quote_author',
            'quote_likes': 'quote_likes',
            'quote_tags': 'quote_tags'
        }

        self._id = id
        self._quote_text = quote_text
        self._quote_author = quote_author
        self._quote_likes = quote_likes
        self._quote_tags = quote_tags

    @classmethod
    def from_dict(cls, dikt) -> 'QuoteItem':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The QuoteItem of this QuoteItem.  # noqa: E501
        :rtype: QuoteItem
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self):
        """Gets the id of this QuoteItem.


        :return: The id of this QuoteItem.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this QuoteItem.


        :param id: The id of this QuoteItem.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def quote_text(self):
        """Gets the quote_text of this QuoteItem.


        :return: The quote_text of this QuoteItem.
        :rtype: str
        """
        return self._quote_text

    @quote_text.setter
    def quote_text(self, quote_text):
        """Sets the quote_text of this QuoteItem.


        :param quote_text: The quote_text of this QuoteItem.
        :type quote_text: str
        """
        if quote_text is None:
            raise ValueError("Invalid value for `quote_text`, must not be `None`")  # noqa: E501

        self._quote_text = quote_text

    @property
    def quote_author(self):
        """Gets the quote_author of this QuoteItem.


        :return: The quote_author of this QuoteItem.
        :rtype: str
        """
        return self._quote_author

    @quote_author.setter
    def quote_author(self, quote_author):
        """Sets the quote_author of this QuoteItem.


        :param quote_author: The quote_author of this QuoteItem.
        :type quote_author: str
        """
        if quote_author is None:
            raise ValueError("Invalid value for `quote_author`, must not be `None`")  # noqa: E501

        self._quote_author = quote_author

    @property
    def quote_likes(self):
        """Gets the quote_likes of this QuoteItem.


        :return: The quote_likes of this QuoteItem.
        :rtype: int
        """
        return self._quote_likes

    @quote_likes.setter
    def quote_likes(self, quote_likes):
        """Sets the quote_likes of this QuoteItem.


        :param quote_likes: The quote_likes of this QuoteItem.
        :type quote_likes: int
        """
        if quote_likes is None:
            raise ValueError("Invalid value for `quote_likes`, must not be `None`")  # noqa: E501

        self._quote_likes = quote_likes

    @property
    def quote_tags(self):
        """Gets the quote_tags of this QuoteItem.


        :return: The quote_tags of this QuoteItem.
        :rtype: str
        """
        return self._quote_tags

    @quote_tags.setter
    def quote_tags(self, quote_tags):
        """Sets the quote_tags of this QuoteItem.


        :param quote_tags: The quote_tags of this QuoteItem.
        :type quote_tags: str
        """
        if quote_tags is None:
            raise ValueError("Invalid value for `quote_tags`, must not be `None`")  # noqa: E501

        self._quote_tags = quote_tags
